"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const D = __importStar(require("../../dialogue_acts"));
const S = __importStar(require("../../state_manip"));
async function default_1($runtime, $ttUtils, $options, $locale, $grammar, $loader) {
    $grammar.declareSymbol("count_aggregation_reply_suffix");
    $grammar.addRule("count_aggregation_reply_suffix", [new $runtime.NonTerminal("ctx_with_aggregation_result", undefined), new $runtime.NonTerminal("base_table", ["functionName", 0, "currentFunction"]), new $runtime.Choice(["like that", "with those characteristics"])], ((ctx, base, $0) => D.makeCountAggregationReplySuffix(ctx, base, false)), S.contextKeyFn, {});
    $grammar.addRule("count_aggregation_reply_suffix", [new $runtime.NonTerminal("ctx_with_aggregation_result", undefined), new $runtime.NonTerminal("one_with_filter_table", ["functionName", 0, "currentFunction"])], ((ctx, table) => D.makeCountAggregationReplySuffix(ctx, table, true)), S.contextKeyFn, { priority: (10) });
    $grammar.addRule("count_aggregation_reply_suffix", [new $runtime.NonTerminal("ctx_with_aggregation_result", undefined), new $runtime.NonTerminal("two_with_filter_table", ["functionName", 0, "currentFunction"])], ((ctx, table) => D.makeCountAggregationReplySuffix(ctx, table, true)), S.contextKeyFn, { priority: (10) });
    $grammar.declareSymbol("count_aggregation_reply");
    $grammar.addRule("count_aggregation_reply", [new $runtime.Choice(["there are", "i see", "i have"]), new $runtime.NonTerminal("constant_Number", undefined), new $runtime.NonTerminal("count_aggregation_reply_suffix", undefined)], (($0, num, ctx) => D.makeCountAggregationReply(ctx, num)), undefined, {});
    $grammar.declareSymbol("agg_operator_for_reply");
    $grammar.addRule("agg_operator_for_reply", ["minimum"], (($0) => 'min'), undefined, {});
    $grammar.addRule("agg_operator_for_reply", ["smallest"], (($0) => 'min'), undefined, {});
    $grammar.addRule("agg_operator_for_reply", ["maximum"], (($0) => 'max'), undefined, {});
    $grammar.addRule("agg_operator_for_reply", ["largest"], (($0) => 'max'), undefined, {});
    $grammar.addRule("agg_operator_for_reply", ["average"], (($0) => 'avg'), undefined, {});
    $grammar.addRule("agg_operator_for_reply", ["total"], (($0) => 'sum'), undefined, {});
    $grammar.declareSymbol("other_aggregation_reply");
    $grammar.addRule("other_aggregation_reply", [new $runtime.NonTerminal("ctx_with_aggregation_result", undefined), "the", new $runtime.NonTerminal("agg_operator_for_reply", undefined), new $runtime.NonTerminal("out_param_Any", undefined), "is", new $runtime.NonTerminal("constant_Any", undefined)], ((ctx, $0, op, p, $1, c) => D.makeOtherAggregationReply(ctx, op, p, c)), undefined, {});
}
exports.default = default_1;
;
//# sourceMappingURL=aggregation-results.genie.js.map