"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const C = __importStar(require("../../ast_manip"));
const D = __importStar(require("../../dialogue_acts"));
const S = __importStar(require("../../state_manip"));
async function default_1($runtime, $ttUtils, $options, $locale, $grammar, $loader) {
    $grammar.declareSymbol("search_result_preamble");
    $grammar.addRule("search_result_preamble", [new $runtime.NonTerminal("ctx_search_command", undefined), new $runtime.Choice(["there are", "i can see", "i have found", "i can recommend"]), new $runtime.Choice(["many", "several"]), new $runtime.NonTerminal("base_noun_phrase", ["functionName", 0, "currentFunction"]), new $runtime.Choice(["matching your request", "matching your constraints", "with those characteristics", "like that", ""]), "."], ((ctx, $0, $1, base, $2, $3) => D.checkSearchResultPreamble(ctx, base, null, false)), S.contextKeyFn, {});
    $grammar.addRule("search_result_preamble", [new $runtime.NonTerminal("ctx_search_command", undefined), new $runtime.Choice(["there are", "i have found", "i have", "i can see"]), new $runtime.NonTerminal("constant_Number", ["value", 0, "resultLength"]), new $runtime.NonTerminal("base_noun_phrase", ["functionName", 0, "currentFunction"]), new $runtime.Choice(["in my database", "like that"]), "."], ((ctx, $0, num, base, $1, $2) => D.checkSearchResultPreamble(ctx, base, num, false)), S.contextKeyFn, {});
    $grammar.declareSymbol("system_generic_proposal");
    $grammar.addRule("system_generic_proposal", [new $runtime.NonTerminal("ctx_search_command", undefined), new $runtime.Choice(["are you looking for a", "how about a", "how about the"]), new $runtime.NonTerminal("answer_noun_phrase", ["functionName", 0, "currentFunction"]), "?"], ((ctx, $0, proposal, $1) => D.makeRefinementProposal(ctx, proposal)), undefined, {});
    $grammar.addRule("system_generic_proposal", [new $runtime.NonTerminal("ctx_search_command", undefined), new $runtime.Choice(["are you looking for", "how about"]), new $runtime.NonTerminal("anything_phrase", ["functionName", 0, "currentFunction"]), "?"], ((ctx, $0, proposal, $1) => D.makeRefinementProposal(ctx, proposal)), undefined, {});
    $grammar.addRule("system_generic_proposal", [new $runtime.NonTerminal("search_result_preamble", undefined), new $runtime.Choice(["are you looking for a", "how about a", "how about the"]), new $runtime.NonTerminal("answer_noun_phrase", ["functionName", 0, "currentFunction"]), "?"], ((ctx, $0, proposal, $1) => D.makeRefinementProposal(ctx, proposal)), undefined, {});
    $grammar.addRule("system_generic_proposal", [new $runtime.NonTerminal("search_result_preamble", undefined), new $runtime.Choice(["are you looking for", "how about", "how about"]), new $runtime.NonTerminal("anything_phrase", ["functionName", 0, "currentFunction"]), "?"], ((ctx, $0, proposal, $1) => D.makeRefinementProposal(ctx, proposal)), undefined, {});
    $grammar.declareSymbol("negative_proposal_request");
    $grammar.addRule("negative_proposal_request", [new $runtime.NonTerminal("counterproposal_preamble", undefined), new $runtime.Choice(["a", "any"]), new $runtime.NonTerminal("answer_noun_phrase", undefined), "."], (($0, $1, request, $2) => request), C.expressionKeyFn, {});
    $grammar.addRule("negative_proposal_request", [new $runtime.NonTerminal("counterproposal_preamble", undefined), new $runtime.NonTerminal("anything_phrase", undefined), "."], (($0, request, $1) => request), C.expressionKeyFn, {});
    $grammar.declareSymbol("negative_proposal_answer_preamble");
    $grammar.addRule("negative_proposal_answer_preamble", [new $runtime.Choice(["no ,", "no", ""]), new $runtime.Choice(["i am not in the mood for a", "i do not like", "i do not want"]), new $runtime.NonTerminal("answer_noun_phrase", undefined)], (($0, $1, phrase) => phrase), C.expressionKeyFn, {});
    $grammar.addRule("negative_proposal_answer_preamble", [new $runtime.Choice(["no ,", "no", ""]), new $runtime.Choice(["i am not in the mood for a", "i do not like", "i do not want"]), new $runtime.NonTerminal("anything_phrase", undefined)], (($0, $1, phrase) => phrase), C.expressionKeyFn, {});
    $grammar.declareSymbol("negative_proposal_reply");
    $grammar.addRule("negative_proposal_reply", [new $runtime.Choice(["no ,", "no", ""]), new $runtime.NonTerminal("negative_proposal_request", undefined)], (($0, request) => [null, request]), D.negativeProposalReplyKeyFn, {});
    $grammar.addRule("negative_proposal_reply", [new $runtime.NonTerminal("negative_proposal_answer_preamble", undefined)], ((preamble) => [preamble, null]), D.negativeProposalReplyKeyFn, {});
    $grammar.addRule("negative_proposal_reply", [new $runtime.NonTerminal("negative_proposal_answer_preamble", undefined), new $runtime.NonTerminal("negative_proposal_request", ["functionName", 0, "functionName"])], ((preamble, request) => [preamble, request]), D.negativeProposalReplyKeyFn, {});
}
exports.default = default_1;
;
//# sourceMappingURL=refinement.genie.js.map