"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2019-2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Silei Xu <silei@cs.stanford.edu>
//         Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const thingtalk_1 = require("thingtalk");
const C = __importStar(require("../ast_manip"));
async function default_1($runtime, $ttUtils, $options, $locale, $grammar, $loader) {
    $grammar.declareSymbol("complete_table");
    $grammar.addRule("complete_table", [new $runtime.NonTerminal("thingpedia_complete_query", undefined)], ((q) => {
        if (q instanceof thingtalk_1.Ast.AggregationExpression)
            return null;
        return q;
    }), C.expressionKeyFn, {});
    if (!$options.flags.notablejoin) {
        $grammar.addRule("complete_table", [new $runtime.NonTerminal("table_join_replace_placeholder", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    }
    $grammar.addRule("complete_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.NonTerminal("preposition_input_param", ["functionName", 0, "functionName"])], ((table, param) => C.addActionInputParam($loader, table, param)), C.expressionKeyFn, {});
    $grammar.addRule("complete_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["with", "having"]), new $runtime.NonTerminal("npp_input_param", ["functionName", 0, "functionName"])], ((table, $0, param) => C.addActionInputParam($loader, table, param)), C.expressionKeyFn, {});
    $grammar.addRule("complete_table", [new $runtime.NonTerminal("apv_input_param", undefined), new $runtime.NonTerminal("complete_table", ["functionName", 0, "functionName"])], ((param, table) => C.addActionInputParam($loader, table, param)), C.expressionKeyFn, {});
    $grammar.addRule("complete_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.NonTerminal("pvp_input_param", ["functionName", 0, "functionName"])], ((table, param) => C.addActionInputParam($loader, table, param)), C.expressionKeyFn, {});
    $grammar.declareSymbol("complete_get_command");
    $grammar.addRule("complete_get_command", [new $runtime.NonTerminal("thingpedia_complete_get_command", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("complete_get_command", [new $runtime.NonTerminal("complete_get_command", undefined), new $runtime.NonTerminal("preposition_input_param", ["functionName", 0, "functionName"])], ((table, param) => C.addActionInputParam($loader, table, param)), C.expressionKeyFn, {});
    $grammar.addRule("complete_get_command", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["with", "having"]), new $runtime.NonTerminal("npp_input_param", ["functionName", 0, "functionName"])], ((table, $0, param) => C.addActionInputParam($loader, table, param)), C.expressionKeyFn, {});
    $grammar.declareSymbol("if_filtered_table");
    if (!$options.flags.always_filter) {
        $grammar.addRule("if_filtered_table", [new $runtime.NonTerminal("complete_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    }
    $grammar.addRule("if_filtered_table", [new $runtime.NonTerminal("one_if_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    if (!$options.flags.turking) {
        $grammar.addRule("if_filtered_table", [new $runtime.NonTerminal("two_if_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    }
    $grammar.declareSymbol("one_if_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_if_filter_table", [new $runtime.NonTerminal("complete_table", undefined), "if", new $runtime.NonTerminal("if_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter, { ifFilter: true })), C.expressionKeyFn, {});
        $grammar.addRule("one_if_filter_table", [new $runtime.NonTerminal("complete_table", undefined), "if", new $runtime.NonTerminal("if_filter", ["functionName", (null)])], ((table, $0, filter) => C.addFilter(table, filter, { ifFilter: true })), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("two_if_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_if_filter_table", [new $runtime.NonTerminal("one_if_filter_table", undefined), "and", new $runtime.NonTerminal("if_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter, { ifFilter: true })), C.expressionKeyFn, {});
        $grammar.addRule("two_if_filter_table", [new $runtime.NonTerminal("one_if_filter_table", undefined), "and", new $runtime.NonTerminal("if_filter", ["functionName", (null)])], ((table, $0, filter) => C.addFilter(table, filter, { ifFilter: true })), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("with_filtered_table");
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("complete_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (3), identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("one_with_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("one_which_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("two_with_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("two_which_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("three_with_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (0.1), identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("three_which_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (0.1), identity: (true) });
    $grammar.addRule("with_filtered_table", [new $runtime.NonTerminal("three_clean_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (0.1), identity: (true) });
    $grammar.declareSymbol("answer_noun_phrase");
    $grammar.addRule("answer_noun_phrase", [new $runtime.NonTerminal("one_with_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (10), identity: (true) });
    $grammar.addRule("answer_noun_phrase", [new $runtime.NonTerminal("one_which_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (10), identity: (true) });
    $grammar.addRule("answer_noun_phrase", [new $runtime.NonTerminal("one_clean_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { weight: (10), identity: (true) });
    $grammar.addRule("answer_noun_phrase", [new $runtime.NonTerminal("two_with_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("answer_noun_phrase", [new $runtime.NonTerminal("two_which_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("answer_noun_phrase", [new $runtime.NonTerminal("two_clean_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.declareSymbol("one_with_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_with_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["with", "having"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_with_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["with", "having"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.turking) {
        if (!$options.flags.nofilter) {
            $grammar.addRule("one_with_filter_table", [new $runtime.NonTerminal("complete_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
    }
    $grammar.declareSymbol("one_which_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_which_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("one_clean_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_clean_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("complete_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_clean_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_clean_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.NonTerminal("preposition_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_clean_filter_table", [new $runtime.NonTerminal("quality_filter", undefined), new $runtime.NonTerminal("complete_table", undefined)], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("two_with_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), "and", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["and having", "and with", ", with", "and have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["with", "having", "that have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), "and", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["and having", "and with", ", with", "and have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["with", "having", "that have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("one_with_filter_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.turking) {
        if (!$options.flags.nofilter) {
            $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_with_filter_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
        if (!$options.flags.nofilter) {
            $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_which_filter_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
        if (!$options.flags.nofilter) {
            $grammar.addRule("two_with_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
    }
    $grammar.declareSymbol("two_which_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and", new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        if (!$options.flags.nofilter) {
            $grammar.addRule("two_which_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("one_which_filter_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        }
    }
    $grammar.declareSymbol("two_clean_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_clean_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("one_clean_filter_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_clean_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_clean_filter_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.NonTerminal("preposition_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_clean_filter_table", [new $runtime.NonTerminal("quality_filter", undefined), new $runtime.NonTerminal("one_clean_filter_table", undefined)], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("three_with_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), "and", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["and having", "and with", ", with", "and have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["with", "having", "that have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), "and", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["and having", "and with", ", with", "and have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["with", "having", "that have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("two_with_filter_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.turking) {
        if (!$options.flags.nofilter) {
            $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_with_filter_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
        if (!$options.flags.nofilter) {
            $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_which_filter_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
        if (!$options.flags.nofilter) {
            $grammar.addRule("three_with_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", ["has_geo", (true)]), new $runtime.NonTerminal("within_filter", undefined)], ((table, filter) => C.makeWithinGeoDistanceExpression(table, filter.place, filter.distance)), C.expressionKeyFn, {});
        }
    }
    $grammar.declareSymbol("three_which_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and", new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), "have", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.Choice(["", ","]), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("reverse_verb_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("three_which_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("two_which_filter_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("three_clean_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("three_clean_filter_table", [new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("two_clean_filter_table", ["functionName", 0, "functionName"])], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_clean_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_clean_filter_table", [new $runtime.NonTerminal("two_clean_filter_table", undefined), new $runtime.NonTerminal("preposition_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("three_clean_filter_table", [new $runtime.NonTerminal("quality_filter", undefined), new $runtime.NonTerminal("two_clean_filter_table", undefined)], ((filter, table) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("anything_phrase");
    $grammar.addRule("anything_phrase", [new $runtime.NonTerminal("anything_with_filter_phrase", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("anything_phrase", [new $runtime.NonTerminal("anything_which_filter_phrase", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("anything_phrase", [new $runtime.NonTerminal("anything_clean_filter_phrase", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.declareSymbol("anything_with_filter_phrase");
    $grammar.addRule("anything_with_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.Choice(["with", "having"]), new $runtime.NonTerminal("npp_filter", ["functionName", 1, "functionName"])], (($0, phrase, $1, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_with_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.Choice(["with", "having"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((phrase, $0, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.declareSymbol("anything_which_filter_phrase");
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["has", "have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 1, "functionName"])], (($0, phrase, $1, $2, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 1, "functionName"])], (($0, phrase, $1, $2, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 1, "functionName"])], (($0, phrase, $1, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 1, "functionName"])], (($0, phrase, $1, $2, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["has", "have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((phrase, $0, $1, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((phrase, $0, $1, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((phrase, $0, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_which_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.Choice(["which", "that"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((phrase, $0, $1, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.declareSymbol("anything_clean_filter_phrase");
    $grammar.addRule("anything_clean_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("apv_filter", undefined), new $runtime.NonTerminal("generic_base_noun_phrase", ["functionName", 1, "functionName"])], (($0, filter, phrase) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_clean_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.NonTerminal("pvp_filter", ["functionName", 1, "functionName"])], (($0, phrase, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_clean_filter_phrase", [new $runtime.Choice(["any", "some"]), new $runtime.NonTerminal("generic_base_noun_phrase", undefined), new $runtime.NonTerminal("preposition_filter", ["functionName", 1, "functionName"])], (($0, phrase, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_clean_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((phrase, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_clean_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((phrase, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.addRule("anything_clean_filter_phrase", [new $runtime.NonTerminal("generic_anything_noun_phrase", undefined), new $runtime.NonTerminal("preposition_filter", ["functionName", 0, "functionName"])], ((phrase, filter) => C.addFilter(phrase, filter)), C.expressionKeyFn, {});
    $grammar.declareSymbol("verb_filtered_table");
    $grammar.addRule("verb_filtered_table", [new $runtime.NonTerminal("one_be_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("verb_filtered_table", [new $runtime.NonTerminal("one_have_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("verb_filtered_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("verb_filtered_table", [new $runtime.NonTerminal("two_be_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("verb_filtered_table", [new $runtime.NonTerminal("two_have_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.addRule("verb_filtered_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    $grammar.declareSymbol("one_be_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_be_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_be_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_be_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("one_be_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("one_have_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_have_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["get", "have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_have_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["get", "have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("one_verb_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("one_verb_filter_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("two_be_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npi_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("apv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_be_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("npv_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("two_have_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_have_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["get", "have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_have_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_have_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["get", "have"]), new $runtime.NonTerminal("with_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_have_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["get", "have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_have_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_have_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["", ","]), "and", new $runtime.Choice(["get", "have"]), new $runtime.NonTerminal("npp_filter", ["functionName", 0, "functionName"])], ((table, $0, $1, $2, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("two_verb_filter_table");
    if (!$options.flags.nofilter) {
        $grammar.addRule("two_verb_filter_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_verb_filter_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
        $grammar.addRule("two_verb_filter_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), "and", new $runtime.NonTerminal("avp_filter", ["functionName", 0, "functionName"])], ((table, $0, filter) => C.addFilter(table, filter)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("generic_argminmax");
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["maximum", "highest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Number))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["minimum", "lowest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Number))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["most costly", "most expensive", "maximum"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Currency))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["least costly", "cheapest", "minimum"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Currency))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["longest", "most lasting"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('ms')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", ["shortest", new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('ms')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["maximum", "largest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('byte')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["minimum", "smallest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('byte')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["heaviest", "largest", "maximum"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('kg')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["lightest", "smallest", "minimum"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('kg')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["hottest", "highest", "maximum"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('C')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["coolest", "lowest", "minimum"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('C')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["farthest", "most distant", "longest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('m')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["nearest", "closest", "shortest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('m')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["largest", "biggest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('m2')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", ["smallest", new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('m2')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["largest", "biggest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('m3')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", ["smallest", new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('m3')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["fastest", "quickest", "speediest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('mps')))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["slowest", "most slowly"]), new $runtime.NonTerminal("out_param_Any", ["type", ((new thingtalk_1.Type.Measure('mps')))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["latest", "most recent"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Date))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["earliest", "soonest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Date))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["latest", "most recent"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Time))])], (($0, p) => [p, 'desc']), C.argMinMaxKeyFn, {});
    $grammar.addRule("generic_argminmax", [new $runtime.Choice(["earliest", "soonest"]), new $runtime.NonTerminal("out_param_Any", ["type", ((thingtalk_1.Type.Time))])], (($0, p) => [p, 'asc']), C.argMinMaxKeyFn, {});
    $grammar.declareSymbol("with_arg_min_max_table");
    if ($options.flags.aggregation) {
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["with", "which has", "which have"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["with", "which has", "which have"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("complete_table", ["functionName", 0, "functionName"])], ((argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["with", "which has", "which have"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["with", "which has", "which have"]), new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("one_clean_filter_table", ["functionName", 0, "functionName"])], ((argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_clean_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), "and the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), "and the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("one_with_filter_table", ["functionName", 0, "functionName"])], ((argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), "and the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), "and the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("two_with_filter_table", ["functionName", 0, "functionName"])], ((argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_with_filter_table", undefined), new $runtime.Choice(["that", "which"]), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and have the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and have the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("one_which_filter_table", ["functionName", 0, "functionName"])], ((argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("one_which_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and have the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and have the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("two_which_filter_table", ["functionName", 0, "functionName"])], ((argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("two_which_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("constant_Number", undefined), new $runtime.NonTerminal("with_filtered_table", ["functionName", 0, "functionName"])], ((argminmax, count, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1], count)), C.expressionKeyFn, {});
        $grammar.addRule("with_arg_min_max_table", [new $runtime.NonTerminal("constant_Number", undefined), new $runtime.NonTerminal("apv_argminmax", undefined), new $runtime.NonTerminal("with_filtered_table", ["functionName", 1, "functionName"])], ((count, argminmax, t) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1], count)), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("have_arg_min_max_table");
    if ($options.flags.aggregation) {
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["has", "gets"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["has", "gets"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("complete_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["has", "gets"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["has", "gets"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_have_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_verb_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.Choice(["", "is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.Choice(["", "is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("one_be_filter_table", undefined), "and", new $runtime.Choice(["", "is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_have_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_have_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_have_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_have_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_have_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_have_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_verb_filter_table", undefined), "and", new $runtime.Choice(["is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_be_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("generic_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_be_filter_table", undefined), new $runtime.Choice(["and", "and has"]), "the", new $runtime.NonTerminal("npp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_be_filter_table", undefined), "and", new $runtime.NonTerminal("avp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_be_filter_table", undefined), "and", new $runtime.Choice(["", "is", "are"]), new $runtime.NonTerminal("pvp_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_be_filter_table", undefined), "and", new $runtime.Choice(["", "is", "are"]), "the", new $runtime.NonTerminal("apv_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, $2, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
        $grammar.addRule("have_arg_min_max_table", [new $runtime.NonTerminal("two_be_filter_table", undefined), "and", new $runtime.Choice(["", "is", "are"]), new $runtime.NonTerminal("preposition_argminmax", ["functionName", 0, "functionName"])], ((t, $0, $1, argminmax) => C.makeArgMaxMinTable(t, argminmax[0].name, argminmax[1])), C.expressionKeyFn, {});
    }
    $grammar.declareSymbol("edge_stream");
    if (!$options.flags.turking) {
        $grammar.addRule("edge_stream", [new $runtime.Choice(["when", "if"]), "the", new $runtime.NonTerminal("projection_Any", undefined), new $runtime.Choice(["becomes", "becomes equal to"]), new $runtime.NonTerminal("constant_Any", undefined)], (($0, $1, p, $2, x) => C.makeEdgeFilterStream($loader, p, '==', x)), C.expressionKeyFn, {});
    }
    $grammar.addRule("edge_stream", [new $runtime.Choice(["when", "if"]), "the", new $runtime.NonTerminal("projection_Any", undefined), new $runtime.Choice(["becomes greater than", "becomes higher than", "goes above", "increases above"]), new $runtime.NonTerminal("constant_Numeric", ["type", 2, "projectionType"])], (($0, $1, p, $2, x) => C.makeEdgeFilterStream($loader, p, '>=', x)), C.expressionKeyFn, {});
    $grammar.addRule("edge_stream", [new $runtime.Choice(["when", "if"]), "the", new $runtime.NonTerminal("projection_Any", undefined), new $runtime.Choice(["becomes smaller than", "becomes lower than", "goes below", "decreases below"]), new $runtime.NonTerminal("constant_Numeric", ["type", 2, "projectionType"])], (($0, $1, p, $2, x) => C.makeEdgeFilterStream($loader, p, '<=', x)), C.expressionKeyFn, {});
    $grammar.declareSymbol("stream");
    $grammar.addRule("stream", [new $runtime.NonTerminal("thingpedia_complete_stream", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    if (!$options.flags.turking) {
        $grammar.addRule("stream", [new $runtime.Choice(["when", "if", "in case", "whenever", "any time", "should", "anytime"]), new $runtime.NonTerminal("with_filtered_table", ["is_monitorable", (true)]), new $runtime.Choice(["change", "update"])], (($0, table, $1) => C.tableToStream(table)), C.expressionKeyFn, {});
    }
    if ($options.flags.turking) {
        $grammar.addRule("stream", [new $runtime.Choice(["when", "if", "in case", "whenever", "any time", "should", "anytime"]), new $runtime.NonTerminal("with_filtered_table", ["is_monitorable", (true)]), "update"], (($0, table, $1) => C.tableToStream(table)), C.expressionKeyFn, {});
    }
    if (!$options.flags.turking) {
        $grammar.addRule("stream", [new $runtime.Choice(["in case of changes", "in case of variations", "in case of updates", "if something changes", "when something changes", "if there are changes", "if there are updates"]), "in", new $runtime.NonTerminal("with_filtered_table", ["is_monitorable", (true)])], (($0, $1, table) => C.tableToStream(table)), C.expressionKeyFn, {});
        $grammar.addRule("stream", [new $runtime.Choice(["when", "if", "in case", "whenever", "any time", "anytime"]), new $runtime.NonTerminal("projection_Any", ["is_monitorable", (true)]), "changes"], (($0, proj, $1) => C.tableToStream(proj)), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("stream", [new $runtime.Choice(["when", "if", "in case", "whenever", "any time", "should", "anytime"]), new $runtime.NonTerminal("complete_table", ["is_monitorable", (true)]), "change and", new $runtime.NonTerminal("edge_filter", undefined)], (($0, table, $1, filter) => {
            if (!table.schema.is_monitorable || !C.checkFilter(table, filter) || table.schema.is_list)
                return null;
            const withFilter = C.addFilter(table, filter, { ifFilter: true });
            if (!withFilter)
                return null;
            return C.tableToStream(withFilter);
        }), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("stream", [new $runtime.Choice(["when", "if", "in case", "whenever", "any time", "should", "anytime"]), new $runtime.NonTerminal("complete_table", ["is_monitorable", (true)]), "change and", new $runtime.NonTerminal("if_filter", undefined)], (($0, table, $1, filter) => {
            if (!table.schema.is_monitorable || !C.checkFilter(table, filter))
                return null;
            if ($loader.flags.turking && table.schema.is_list)
                return null;
            const withFilter = C.addFilter(table, filter, { ifFilter: true });
            if (!withFilter)
                return null;
            return C.tableToStream(withFilter);
        }), C.expressionKeyFn, {});
    }
    if (!$options.flags.nofilter) {
        $grammar.addRule("stream", [new $runtime.NonTerminal("edge_stream", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    }
    if ($options.flags.timer) {
        $grammar.addRule("stream", [new $runtime.NonTerminal("timer", undefined)], (($0) => { return $0; }), C.expressionKeyFn, { identity: (true) });
    }
    $grammar.declareSymbol("with_filtered_table_join");
    if (!$options.flags.notablejoin) {
        $grammar.addRule("with_filtered_table_join", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["with", "having", "that has", "that have", "which has", "which have"]), new $runtime.NonTerminal("with_filtered_table", undefined)], ((table, $0, get_predicate_table) => C.addGetPredicateJoin(table, get_predicate_table, null)), C.expressionKeyFn, {});
        $grammar.addRule("with_filtered_table_join", [new $runtime.NonTerminal("with_filtered_table", undefined), "with", new $runtime.NonTerminal("out_param_Any", undefined), new $runtime.NonTerminal("with_filtered_table", undefined)], ((table, $0, p, get_predicate_table) => C.addGetPredicateJoin(table, get_predicate_table, p.name)), C.expressionKeyFn, {});
        $grammar.addRule("with_filtered_table_join", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.NonTerminal("out_param_pvp", undefined), new $runtime.NonTerminal("with_filtered_table", undefined)], ((table, p, get_predicate_table) => C.addGetPredicateJoin(table, get_predicate_table, p.name)), C.expressionKeyFn, {});
        $grammar.addRule("with_filtered_table_join", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["who", "which", "that"]), new $runtime.NonTerminal("out_param_avp", undefined), new $runtime.NonTerminal("with_filtered_table", undefined)], ((table, $0, p, get_predicate_table) => C.addGetPredicateJoin(table, get_predicate_table, p.name)), C.expressionKeyFn, {});
        $grammar.addRule("with_filtered_table_join", [new $runtime.NonTerminal("with_filtered_table", undefined), new $runtime.Choice(["of", "for", "in"]), new $runtime.NonTerminal("with_filtered_table", undefined)], ((rhs, $0, lhs) => C.addArrayJoin(lhs, rhs)), C.expressionKeyFn, {});
        if (!$options.flags.turking) {
            $grammar.addRule("with_filtered_table_join", [new $runtime.NonTerminal("with_filtered_table", undefined), "'s", new $runtime.NonTerminal("with_filtered_table", undefined)], ((lhs, $0, rhs) => C.addArrayJoin(lhs, rhs)), C.expressionKeyFn, {});
        }
    }
    $grammar.declareSymbol("have_filtered_table_join");
    if (!$options.flags.notablejoin) {
        $grammar.addRule("have_filtered_table_join", [new $runtime.NonTerminal("verb_filtered_table", undefined), new $runtime.Choice(["and", "and have", "and also", "and in addition", "but also"]), new $runtime.NonTerminal("with_filtered_table", undefined)], ((table, $0, get_predicate_table) => C.addGetPredicateJoin(table, get_predicate_table, null)), C.expressionKeyFn, {});
    }
}
exports.default = default_1;
;
//# sourceMappingURL=stream_tables.genie.js.map